--[[ **************************************************************************
     * Add On Starts Here                                                     *
	 **************************************************************************
]]

local on = true
local off = false

AchSnd_Defaults = {
-- Default Settings   All settings can be changed in game with
-- the /achsnd command (command = variable name (case insensitive))
Guild = on, -- Enable on guild member achievements
Party = on, -- Enable on party members achievements
Near = on,  -- Enable for people near you
PvP = off, -- Enable when you are in an active pvp zone
--
-- Addon Output Settings
MSBT = on,  -- Output achievement to Mik's Scrolling Battle Text
Popup = on, -- Grats popup
Sound = on, -- Enable Sound Output
CustomMP3 = off, -- Enable custom alert.mp3
CustomOGG = off, -- Enable custom alert.ogg
Timeout = 15, -- Popup timeout between 0 - 60 secs
Multi = on, -- Enable Multi Guild grats
MultiAmount = 7, -- How Many Guildies before a Whole Guild Grat
Names = on, -- Use player names in random messages
NNames = on, -- Use supplied Nick Names when match found
MaxNames = 5, -- Max number of names to use in message
Random = on, -- Random messages or default
Flourishes = on, -- Enable the message flourishes
RaidIcons = on, -- Enable Raid Icons in the flourishes (in party / guild)
DefaultMsg = "{star} Grats {star}", -- Default Grats Message
NewMsgBox = on, -- Enables the new Achievement Alert frame
AutoFade = on, -- Enables new alert frame to auto-fade when mouse not over it
MinAlpha = 35, -- Minimum alpha the frame will fade to
FadeDelay = 3, -- How long before frame fades to above alpha
--
-- Addon State
Enable = on -- enable/disable the addon 
}

AchSnd_DefaultsPC = {
AlertPosSet = false --Per char alert box pos saved
}


AchSnd_Settings = {}
AchSnd_SettingsPC = {}
AchSnd_NN = {} -- Nicknames
local NN -- Alias for AchSnd_NN[Realm]

AchSnd={}
AchSnd.MBox = {}
AchSnd.MBox.Test = false
AchSnd.MBox.Mode = {say = {}, guild = {}, party = {} }

AchSnd.Frame = CreateFrame("Frame")
AchSnd.Frame:RegisterEvent("ADDON_LOADED")
AchSnd.Frame:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
AchSnd.Frame:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")

-- Local text colors
local yel = "|cFFFFFF00"
local wht = "|cFFFFFFFF"
local blu = "|cFF00FFFF"
local red = "|cFFFF0000"
local grn = "|cFF00FF00"
local res = "|r"

-- Bill's Utils
local addOptionMt = BillsUtils.addOptionMt
local StatColor = BillsUtils.StatColor
local SJprint = BillsUtils.SJprint
local LinkedSort = BillsUtils.LinkedSort
local OptSaveTF = BillsUtils.OptSaveTF
local OptSaveVal = BillsUtils.OptSaveVal
local SameFaction = BillsUtils.SameFaction
local IsPvPZone = BillsUtils.IsPvPZone

BillsUtils.Locals[#BillsUtils.Locals +1] = function () --function is called if/when a newer version of Bill's Utils loads after the addon is loaded
	addOptionMt = BillsUtils.addOptionMt
	StatColor = BillsUtils.StatColor
	SJprint = BillsUtils.SJprint
	LinkedSort = BillsUtils.LinkedSort
	OptSaveTF = BillsUtils.OptSaveTF
	OptSaveVal = BillsUtils.OptSaveVal
	SameFaction = BillsUtils.SameFaction
	IsPvPZone = BillsUtils.IsPvPZone
end

AchSnd.TextScanError  = function( text )
	for loop = 1, #text do
		if (string.byte( text, loop) > 127) then
			return true
		end
	end
	return false
end

StaticPopupDialogs["AchSnd.TextError"] = {
	text = "Message text cannot contain characters with an ASCII value greater than 127",
	button1 = "Okay",
	timeout = 20,
	showAlert = true
	}


AchSnd.Add = function( name, nick )
	local set = false
	
	if name == nil or nick == nil then
		SJprint( yel, " Achievement Sounds: Nick Name entry error \n \"/asnn add NAME NICKNAME\"", res)
		return
	end
	
	if #NN.Names > 0 then
		for x = 1, #NN.Names do
			if NN.Names[x] == name then
				NN.Nicks[x] = nick
				set = true
				break
			end
		end
	end
	
	if not(set) then
		local index
		if #NN.Names == nil then
			index = 1
		else
			index = #NN.Names + 1
		end
		
		NN.Names[index] = name
		NN.Nicks[index] = nick
	end

	SJprint( yel, " Achievement Sounds: Nickname stored as NAME:", name, "  NICKNAME:", nick , res)
	LinkedSort(NN.Names, NN.Nicks)	
end

AchSnd.Rem = function( name )
	local rem = false
	local vtype = type(name)
	
	if vtype == "nil" then
		SJprint( yel, " Achievement Sounds: Nick Name entry error \n \"/asnn rem NAME \"", res)
		return
	end

	if vtype == "string" then
		if #NN.Names > 0 then
			for x = 1, #NN.Names do
				if NN.Names[x] == name then
					table.remove(NN.Names, x)
					table.remove(NN.Nicks, x)
					rem = true
					break
				end
			end
		end
	else
		local number = tonumber(name)
		if number > 0 and number <= #NN.Names then
			name = NN.Names[number]
			table.remove(NN.Names, number)
			table.remove(NN.Nicks, number)
			rem = true
		end
	end
	
	if not(rem) then
		SJprint( yel, " Achievement Sounds: Error \n Unable to find NAME:", name, " to remove from nickname list", res)
	else
		SJprint( yel, " Achievement Sounds: NAME:", name, " removed from nickname list", res)
	end
end

AchSnd.NickNames = function( msg )
	local cmd, arg, nick = string.split(" ", msg)
	cmd = cmd:lower()
	
	if cmd == "nn" or cmd == "nnames" then
		_, cmd, arg, nick =  string.split(" ", msg)
		cmd = cmd:lower()
	end
	
	local name = arg
	
	if cmd == "on" or cmd == "off" then
		AchSnd_Settings.NNames = (cmd == "on")
		SJprint( yel, "Achievement Sounds: NNames is", StatColor( AchSnd_Settings.NNames ), res)
		return
	end
	
	if (cmd == "add") then
		AchSnd.Add( name, nick )
		return
	end

	if (cmd == "rem") then
		AchSnd.Rem( name )
		return	
	end
		
	if (cmd == "display") then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  Nick Names List", res)
		SJprint( yel, "#  NAME:               NICK:", res)
		if #NN.Names > 0 then
			for x = 1, #NN.Names do
				SJprint( yel, x, " ", NN.Names[x], string.rep( " ",15 - #NN.Names[x]), NN.Nicks[x], "\n", res)
			end
		else
			SJprint( yel, "ERROR: No Nicknames Stored", res)
		end
		return
	end
	
	SJprint( yel, "________________________________________", res)
	SJprint( yel, "Achievement Sounds", res)
	SJprint( yel, "  Nick Names", res)
	if cmd ~= "" then
		SJprint( red, "  Error:", cmd, "is not a valid command", res)
		SJprint( yel, "Valid commands are as follows\n", res)
	end
	
	SJprint( blu, "  /achsnd nnames cmd", yel, "or", blu, "/achsnd nn cmd", res)
	SJprint( blu, "  /asnn cmd", res)
	SJprint( yel, "  Commands are:", res)
	SJprint( blu, "     on", yel, "/", blu, "off", wht, "Turns Nick Names on and off", res)
	SJprint( blu, "     add", wht, "Adds or replaces a nickname \"/asnn add NAME NICKNAME\"", res)
	SJprint( blu, "     rem", wht, "Removes a nickname \"/asnn rem NAME\" or \"/asnn rem NUMBER\"", res)
	SJprint( blu, "     display", wht, "Displays list of saved nicknames", res)
	print(" ")
	SJprint( yel, "Achievement Sounds: NNames is", StatColor( AchSnd_Settings.NNames ), res)
	SJprint( yel, "and ", #NN.Names, "nicknames are stored.")
	return
end


AchSnd.CleanNames = function()
	-- sorts dupes from individual queues
	local modes = {"guild", "party", "say"}
	for x = 1, #modes do 
		Table = AchSnd.MBox.Mode[modes[x]]
		if #Table > 1 then
			table.sort(Table)
			for y = #Table -1, 1, -1 do
				if Table[y] == Table[y+1] then
					table.remove(Table, y+1)
				end
			end
		end
	end
	
	-- sorts dupes comparing primary to secondary and removing from secondary
	local primary = { "guild", "guild", "party"}
	local secondary = { "party", "say", "say"}
	for x = 1, #primary do
		local PTable = AchSnd.MBox.Mode[primary[x]]
		local STable = AchSnd.MBox.Mode[secondary[x]]
		if #PTable > 0 then
			for y = 1, #PTable do
				for z = #STable, 1, -1 do
					if PTable[y] == STable[z] then
						table.remove(STable, z)
					end
				end
			end
		end
	end
end


AchSnd.Nicks = function()
	local modes = {"guild", "party", "say"}
	-- swaps in nick names and then resorts each queue
	for x = 1, #modes do 
		Table = AchSnd.MBox.Mode[modes[x]]
		if #Table > 0 then
			for y = 1, #Table do
				for z =1, #NN.Names do
					if Table[y] == NN.Names[z] then
						Table[y] = NN.Nicks[z]
					end
					
				end
			end
			table.sort(Table)
		end
	end
end

-- Duplicate Grat msg creation prevention
local oldflourishnum = 0
local oldgratnum = 0
local oldplurnum = 0
local olderflourishnum = 0
local oldergratnum = 0
local oldperlurnum = 0

AchSnd.RandMsg=function()
	local GUILD = GetGuildInfo("player")
	
	if AchSnd_Settings.NNames then
		AchSnd.Nicks()
	end
	
	AchSnd.CleanNames()
	
	while #AchSnd.MBox.Mode.guild > 0 or #AchSnd.MBox.Mode.party > 0 or #AchSnd.MBox.Mode.say > 0 do
		local wholeguild = false
		local mode = ""
		local playernames
		local msg = ""
		
		if #AchSnd.MBox.Mode.guild > 0 then
			mode = "GUILD"
			playernames = AchSnd.MBox.Mode.guild
			for x = 1, #playernames do
				if playernames[x] == GUILD then
					wholeguild = true
				end
			end
		elseif #AchSnd.MBox.Mode.party > 0 then
			mode = "PARTY"
			playernames = AchSnd.MBox.Mode.party
		elseif #AchSnd.MBox.Mode.say > 0 then
			mode = "SAY"
			playernames = AchSnd.MBox.Mode.say
		else
			return
		end
				
		-- Grats Selector
		do
			local gratnum
			local grtz = {"Grats" , "Congratulations" , "Gratz" , "Grats on the Ach." , "GrAtS" , "Congrats", "CoNgRaTs"}
			repeat
				gratnum = math.random(1, #grtz)
			until gratnum ~= oldgratnum and gratnum ~= oldergratnum
			oldergratnum, oldgratnum = oldgratnum, gratnum
			msg = grtz[gratnum]
		end
		
		if AchSnd_Settings.Multi and (#playernames > 1 or wholeguild ) then
			if #playernames > AchSnd_Settings.MultiAmount or wholeguild then
				-- Plurals Selector
				local plurnum
				local plurals = { "Peeps", "Peoples", "Everyone", "to All of You", "My Guildies", "Guildies", "Guildinators"}
				local notguildoffset = 3
				if mode == "GUILD" then
					repeat
						plurnum = math.random(1, #plurals)
					until plurnum ~= oldplurnum and plurnum ~= olderplurnum
				else
					repeat
						plurnum = math.random(1, #plurals - notguildoffset)
					until plurnum ~= oldplurnum and plurnum ~= olderplurnum
				end
				olderplurnum ,oldplurnum = oldplurnum, plurnum
				msg = string.format("%s %s", msg, plurals[plurnum] )	
			else
				if AchSnd_Settings.Names and #playernames <= AchSnd_Settings.MaxNames then
					local retstr = ""
					for x = 1, #playernames do
						if x == 1 then
							retstr = string.format("[%s]", playernames[x])
						elseif x == #playernames then
							retstr = string.format("%s and [%s]", retstr, playernames[x])
						else
							retstr = string.format("%s, [%s]", retstr, playernames[x])
						end
					end
					msg = string.format("%s %s",msg , retstr)
				else
					msg = string.format("%s you %i", msg, #playernames )
				end
			end
		else -- not multi or single grat
			if AchSnd_Settings.Names then
				msg = string.format("%s %s", msg, playernames[1] )
			else
				-- msg already a grats so nothing to do
			end
		end

		-- Flourishes
		if AchSnd_Settings.Flourishes then
			local flourishes = {"..||..<(+_ %s _+)>..||..", "-o--{ %s }--o-", "<(  0)> %s <(0  )>", "- - --^[ %s ]^-- - -", "( ' __ ' ) %s ( ' __ ' )",
				">---> %s <---<", "><(((('> %s <'))))><", ".||.<(+_+)>.||/. %s .||.<(+_+)>.||/.", "-<<ALERT>>- %s -<<ALERT>>-", "->] %s [<-",
				"--<-@ %s @->--", "->>X<<- %s ->>X<<-", "(>^^)> %s <(^^<)",
				-- 16 following ones use raid icons so not suitable for say
				-- can also be disabled
				"{star}{star} %s {star}{star}", "{circle}{circle} %s {circle}{circle}", "{diamond}{diamond} %s {diamond}{diamond}", "{triangle}{triangle} %s {triangle}{triangle}",
				"{moon}{moon} %s {moon}{moon}", "{square}{square} %s {square}{square}", "{x}{x} %s {x}{x}", "{skull}{skull} %s {skull}{skull}",
				"{star} %s {star}", "{circle} %s {circle}", "{diamond} %s {diamond}", "{triangle} %s {triangle}",
				"{moon} %s {moon}", "{square} %s {square}", "{x} %s {x}", "{skull} %s {skull}",
				}
			local RaidIconOffset = 16
			local flourishnum = 0
			if AchSnd_Settings.RaidIcons and mode ~= "SAY" then
				repeat 
					flourishnum = math.random(1, #flourishes)
				until flourishnum ~= oldflourishnum and flourishnum ~= olderflourishnum
			else
				repeat
					flourishnum = math.random(1, #flourishes - RaidIconOffset )
				until flourishnum ~= oldflourishnum and flourishnum ~= olderflourishnum
			end
			
			olderflourishnum, oldflourishnum = oldflourishnum, flourishnum
			msg = string.format(flourishes[flourishnum], msg)
		end
		SendChatMessage( msg, mode)
		
		wholeguild = false
		
		if mode == "GUILD" or not( AchSnd_Settings.Multi ) then
			wipe(AchSnd.MBox.Mode.guild)
		end
		if mode == "PARTY" or not ( AchSnd_Settings.Multi ) then
			wipe(AchSnd.MBox.Mode.party)
		end
		if mode == "SAY" or not( AchSnd_Settings.Multi ) then
			wipe(AchSnd.MBox.Mode.say)
		end
	end
	return 
end

AchSnd.DefMsg=function()
	if AchSnd_Settings.Multi then
		if #AchSnd.MBox.Mode.guild > 0 then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "GUILD" )
		end
		if #AchSnd.MBox.Mode.party > 0 then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "PARTY" )
		end
		if #AchSnd.MBox.Mode.say > 0 then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "SAY" )
		end
	else
		if #AchSnd.MBox.Mode.guild > 0 then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "GUILD" )
		elseif #AchSnd.MBox.Mode.party > 0 then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "PARTY" )
		elseif #AchSnd.MBox.Mode.say > 0 then
			SendChatMessage( AchSnd_Settings.DefaultMsg , "SAY" )
		end
	end
	wipe(AchSnd.MBox.Mode.guild)
	wipe(AchSnd.MBox.Mode.party)
	wipe(AchSnd.MBox.Mode.say)
end


AchSnd.Frame:SetScript("OnEvent",function(self, event,...)
	if event == "ADDON_LOADED" then
		local arg = ...
		if arg ~= "AchSnd" then
			return
		end
		
		print("\n\nAchievement Sounds loaded\n\n")
		addOptionMt( AchSnd_Settings , AchSnd_Defaults )
		addOptionMt( AchSnd_SettingsPC , AchSnd_DefaultsPC )
		
		if not(AchSnd_SettingsPC.AlertPosSet) and AchSnd_Settings.NewMsgBox then
			AchSnd.MsgFrame:Show()
		end
		
		local realm = GetRealmName()
		local set = false
		
		if #AchSnd_NN > 0 then
			for x = 1, #AchSnd_NN do
				if AchSnd_NN[x].Realm == realm then
					NN = AchSnd_NN[x]
					set = true
					break
				end
			end
		end
		
		if #AchSnd_NN == nil and not(set) then
			AchSnd_NN[1] = { Nicks = {}, Names = {}, Realm = realm}
			NN = AchSnd_NN[1]
			set = true
		end
		
		if not(set) then
			local index = #AchSnd_NN + 1
			AchSnd_NN[index] = {Realm = realm, Names = {}, Nicks = {}}
			NN = AchSnd_NN[index]
		end
		
		AchSnd.NNTable = NN
		
		return self, event, ...
	end
	
	if not(AchSnd_Settings.Enable) then
		return
	end
	
	if not(AchSnd_Settings.PvP) and IsPvPZone() then
		return
	end
		
	local args = {...}
	local color = {255,255,255}
	local msg = args[1]:format(args[5])
	local name = args[5]
	local GUID = args[12]
	
	if name == UnitName("player") then
		return
	end
	
	if not( SameFaction( GUID )) then
		return
	end
	
	if event == "CHAT_MSG_ACHIEVEMENT" then
		if UnitInParty( name ) then
			if not(AchSnd_Settings.Party) then 
				return
			end
			color = {0,255,255}
			AchSnd.MBox.Mode.party[#AchSnd.MBox.Mode.party + 1] = name
		else
			if not(AchSnd_Settings.Near)then
				return
			end
			color = {255,255,255}
			AchSnd.MBox.Mode.say[#AchSnd.MBox.Mode.say + 1] = name
		end
	end
	
	if event == "CHAT_MSG_GUILD_ACHIEVEMENT" then
		if not(AchSnd_Settings.Guild) then
			return
		end
		color = {0,255,0}
		AchSnd.MBox.Mode.guild[#AchSnd.MBox.Mode.guild + 1] = name
	end
	
	if AchSnd_Settings.MSBT and IsAddOnLoaded("MikScrollingBattleText") then
		if not(MikSBT.IsModDisabled()) then
			MikSBT.DisplayMessage( msg , MikSBT.DISPLAYTYPE_NOTIFICATION, true, color[1], color[2], color[3])
		end
	end

	if AchSnd_Settings.Sound then
		if AchSnd_Settings.CustomMP3 then
			PlaySoundFile("Interface\\AddOns\\AchSnd\\alert.mp3")
		elseif AchSnd_Settings.CustomOGG then
			PlaySoundFile("Interface\\AddOns\\AchSnd\\alert.ogg")
		else
			PlaySound("LEVELUPSOUND")
		end
	end
	
	if AchSnd_Settings.Popup then
		if AchSnd_Settings.NewMsgBox then
			AchSnd.ScrollingMessageFrame:AddMessage(tostring(AchSnd.ScrollingMessageFrame:GetNumMessages() +1)..". "..msg, color[1], color[2], color[3])
			AchSnd.MsgFrame:Show()
		else
			local mode = AchSnd.MBox.Mode
			local Button1Txt = ""
			if #mode.say > 0 and #mode.guild == 0 and #mode.party == 0 then
				Button1Txt = "Say Grats"
			elseif #mode.say == 0 and #mode.guild > 0 and #mode.party == 0 then
				Button1Txt = "Guild Grats"
			elseif #mode.say == 0 and #mode.guild == 0 and #mode.party > 0 then
				Button1Txt = "Party Grats"
			else
				Button1Txt = "Mixed Grats"
			end
			
			StaticPopupDialogs["AchSnd.PopUp"] = {
			text = msg,
			button1 = Button1Txt ,
			button2 = "Cancel",
			OnAccept = function(self)
				if AchSnd_Settings.Random then
					AchSnd.RandMsg()
				else
					AchSnd.DefMsg()
				end
			end,
			OnCancel = function( self )
				wipe(AchSnd.MBox.Mode.guild)
				wipe(AchSnd.MBox.Mode.party)
				wipe(AchSnd.MBox.Mode.say)
			end,
			timeout = AchSnd_Settings.Timeout
			}	
			StaticPopup_Show("AchSnd.PopUp")
		end
	else
		wipe(AchSnd.MBox.Mode.guild)
		wipe(AchSnd.MBox.Mode.party)
		wipe(AchSnd.MBox.Mode.say)
	end
end)



SLASH_ACHSND1 = "/achsnd"
SLASH_ACHSND2 = "/achievementsounds"
SlashCmdList["ACHSND"] = function(msg)
	local cmd,arg = string.split(" ", msg)
	cmd = cmd:lower()
	
	if cmd =="config" then
		InterfaceOptionsFrame_OpenToCategory( AchSnd.panel )
		return
	end
	
	if not(AchSnd_Settings.Enable) and cmd ~= "enable" then
		print(" ")
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  This addon is ", red, "DISABLED", res)
		SJprint( yel, "  Type: ", blu, "/achsnd enable on", res)
		SJprint( yel, "  to enable.", res)
		return
	end

	if cmd == "nn" or cmd == "nnames" then
		AchSnd.NickNames( msg )
		print(" ")
		SJprint(yel, "try ", blu, "/asnn", yel, "for less typing.", res)
		return
	end

	--On/Off True/False values
	local Command = {"Enable", "Guild", "Party", "Near", "PvP", "Sound", "CustomMP3", "CustomOGG",
	"MSBT", "Popup", "Multi", "Names", "Random", "Flourishes", "RaidIcons", "NewMsgBox", "AutoFade"}
	
	for x = 1, #Command do
		if cmd == string.lower(Command[x]) then
			OptSaveTF( AchSnd_Settings, Command[x], arg)
			SJprint(  yel, "Achievement Sounds:", Command[x],"is", StatColor( AchSnd_Settings[Command[x]] ), res)
			return
		end
	end


	--Numeric values options = min/max values
	local Command = {"Timeout", "MultiAmount", "MaxNames", "MinAlpha", "FadeDelay"}
	local options = {{0,60},     {0,129},       {0,10},     {0,100},    {0,AchSnd_Settings.FadeDelay} }
	
	for x = 1, #Command do
		if cmd == string.lower(Command[x]) then
			OptSaveVal( AchSnd_Settings, Command[x], arg, options[x][1], options[x][2] )
			SJprint( yel, "Achievement Sounds:", Command[x],"is", StatColor( AchSnd_Settings[Command[x]] ), res)
			return
		end
	end

	if cmd == "" then
		print(" ")
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  Addon State:", res)
		SJprint( blu, "     Enable", wht, "is", StatColor(AchSnd_Settings.Enable), res)
		SJprint( yel, "  Triggers:", res)
		SJprint( blu, "     Guild", wht, "achievements are", StatColor(AchSnd_Settings.Guild), res)
		SJprint( blu, "     Party", wht, "achievements are", StatColor(AchSnd_Settings.Party), res)
		SJprint( blu, "     Near ", wht, "achievements are", StatColor(AchSnd_Settings.Near), res)
		SJprint( blu, "     PvP ", wht, "zones are", StatColor(AchSnd_Settings.PvP), res)
		SJprint( yel, "  Outputs:", res)
		SJprint( blu, "     Sound", wht, "is", StatColor(AchSnd_Settings.Sound), res)
		SJprint( blu, "     CustomMP3", wht, "is", StatColor(AchSnd_Settings.CustomMP3), res)
		SJprint( blu, "     CustomOGG", wht, "is", StatColor(AchSnd_Settings.CustomOGG), res)
		SJprint( blu, "     MSBT ", wht, "is", StatColor(AchSnd_Settings.MSBT), res)
		SJprint( blu, "     Popup", wht, "is", StatColor(AchSnd_Settings.Popup), res)
		SJprint( blu, "     Timeout", wht, "is", StatColor(AchSnd_Settings.Timeout), res)
		SJprint( blu, "     Multi", wht, "is", StatColor(AchSnd_Settings.Multi), res)
		SJprint( blu, "     MultiAmount", wht, "is", grn, AchSnd_Settings.MultiAmount, res)
		SJprint( blu, "     Names", wht, "is", StatColor(AchSnd_Settings.Names), res)
		SJprint( blu, "     NNames", wht, "is", StatColor(AchSnd_Settings.NNames), res)
		SJprint( blu, "     MaxNames", wht, "is", grn, AchSnd_Settings.MaxNames, res)
		SJprint( blu, "     Random", wht, "is", StatColor(AchSnd_Settings.Random), res)
		SJprint( blu, "     Flourishes", wht, "is", StatColor(AchSnd_Settings.Flourishes), res)
		SJprint( blu, "     RaidIcons", wht, "is", StatColor(AchSnd_Settings.RaidIcons), res)
		SJprint( blu, "     DefaultMsg", wht, "is \"", grn, AchSnd_Settings.DefaultMsg, wht, "\"", res)
		SJprint( blu, "     NewMsgBox", wht, "is", StatColor(AchSnd_Settings.NewMsgBox), res)
		SJprint( blu, "     AutoFade", wht, "is", StatColor(AchSnd_Settings.AutoFade), res)
		SJprint( blu, "     MinAlpha", wht, "is", grn, AchSnd_Settings.MinAlpha, res)
		SJprint( blu, "     FadeDelay", wht, "is", StatColor(AchSnd_Settings.FadeDelay), res)
		SJprint( yel, "Available commands are listed above in", blu, "BLUE.", res)
		SJprint( yel, "Type", blu, "/achsnd config", yel, "to open the GUI config screen.", res)
		SJprint( yel, "Type", blu, "/achsnd cmdlist", yel, "for a description of commands.", res)
		SJprint( yel, "________________________________________", res)
		return
	end

	if cmd == "cmdlist" or cmd == "help" then
		print(" ")
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Achievement Sounds", res)
		SJprint( yel, "  Addon State:", res)
		SJprint( blu, "     Enable", wht, "Turns the Add On on and off", res)
		SJprint( yel, "  Triggers:", res)
		SJprint( blu, "     Guild", wht, "Enable for guild member achievements ( on / off)", res)
		SJprint( blu, "     Party", wht, "Enable for party member achievements ( on / off)", res)
		SJprint( blu, "     Near ", wht, "Enable for achievements of people near you ( on / off)", res)
		SJprint( blu, "     PvP ", wht, "Enable achievement alerts when you are in an avtive PvP zone ( on / off)", res)
		SJprint( yel, "  Outputs:", res)
		SJprint( blu, "     Sound", wht, "Enable a sound when an achievement is detected ( on / off)", res)
		SJprint( blu, "     CustomMP3", wht, "Enable a custom alert.mp3 when an achievement is detected ( on / off)", res)
		SJprint( blu, "     CustomOGG", wht, "Enable a custom alert.ogg when an achievement is detected ( on / off)", res)
		SJprint( blu, "     MSBT", wht, "Send the achievement text to MikScrollingBattleText ( on / off)", res)
		SJprint( blu, "     Popup", wht, "Show a Popup when an achievement is detected ( on / off)", res)
		SJprint( blu, "     Timeout", wht, "How long before the popup closes itself (0 - 60 seconds)", res)
		SJprint( blu, "     Multi", wht, "Detect when more than one guild member gets an achievement ( on / off)", res)
		SJprint( blu, "     MultiAmount", wht, "Over this amount give a whole guild grats instead of normal grat", res)
		SJprint( blu, "     Names", wht, "Display Names in the random grats", res)
		SJprint( blu, "     NNames", wht, "Displays NickNames for players names if saved. \n Type \"", blu, "/asnn", wht, "\"for more info", res)
		SJprint( blu, "     MaxNames", wht, "Max number of names to display (should be around 5 or gets spammy)\n     (Max is 10)", res)
		SJprint( blu, "     Random", wht, "Display a random grat instead of default one ( on / off)", res)
		SJprint( blu, "     Flourishes", wht, "Display the flourishes in random grat ( on / off)", res)
		SJprint( blu, "     RaidIcons", wht, "Use Raid Icons in party/guild grats ( on / off)", res)
		SJprint( blu, "     DefaultMsg", wht, "The default message if Random is off", res)
		SJprint( blu, "     NewMsgBox", wht, "Enables moveable popup instead of old style popup ( on / off)", res)
		SJprint( blu, "     AutoFade", wht, "Enables moveable popup to fade after a delay ( on / off)", res)
		SJprint( blu, "     MinAlpha", wht, "The minimum the new frame is allowed to fade to (0 - 1)", res)
		SJprint( blu, "     FadeDelay", wht, "How long the newly shown popup will be visible at 100% before fading (0 - Timeout seconds)", res)
		SJprint( yel, "Available commands are listed above in ", blu, "BLUE.", res)
		SJprint( yel, "Type ", blu, "/achsnd config",  yel, " to open the GUI config screen.", res)
		SJprint( yel, "________________________________________", res)
		return
	end

	if cmd == "defaultmsg" then
		if arg then
			if AchSnd.TextScanError(arg) then
				StaticPopup_Show("AchSnd.TextError")
				return
			end
			AchSnd_Settings.DefaultMsg = string.trim(string.sub( msg, #cmd +1))
		end
		SJprint( yel, "Achievement Sounds: DefaultMsg is \"", grn, AchSnd_Settings.DefaultMsg, yel, "\"", res)
		return
	end
	if cmd == "mbtest" then
		local ach = {GetLatestCompletedAchievements()}
		for x = 1, #ach do
			AchSnd.ScrollingMessageFrame:AddMessage(tostring(AchSnd.ScrollingMessageFrame:GetNumMessages() +1)..". "..GetAchievementLink(ach[x]), 255, 255, 255)
		end
		AchSnd.MsgFrame:Show()
		return
	end
	
	print(" ")
	SJprint( yel, "  Achievement Sounds", res)
	SJprint( yel, "  Error: ", red, cmd, yel, " is not a valid command", res)
	SJprint( yel, "  Type: ", blu, "/achsnd", yel, "for the addon status and command list", res)
	SJprint( yel, "  Type: ", blu, "/achsnd cmdlist", yel, "for command list help", res)
	return
end

SLASH_ACHSNDNN1 = "/asnn"
SlashCmdList["ACHSNDNN"] = function(msg)
	AchSnd.NickNames(msg)
end

